define(["require", "exports", "inversify", "../factory/provide_decorator_factory"], function (require, exports, inversify_1, provide_decorator_factory_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function autoProvide(container) {
        var modules = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            modules[_i - 1] = arguments[_i];
        }
        var provide = provide_decorator_factory_1.default(container);
        modules.forEach(function (module) {
            Object.keys(module).forEach(function (key) {
                var entity = module[key];
                var decorator = provide(entity);
                inversify_1.decorate(decorator, entity);
            });
        });
    }
    exports.default = autoProvide;
});
